/*
 * u7a2_queue.cpp
 * 
 * Musterloesung zu Uebung 7, Informatik I, D-ITET, WS 03/04
 *
 * Richard Keiser, 10.12.2002
 */

#include <iostream>
using namespace std;

// Einbinden der Deklaration unseres neuen Datentyps
#include "u7a2_queue.h"

////////////////////////////////////////////////////////////
// Initialisierung eines Stack und eines Stack-Elements

void initNewQueue(fifoQueue* q)
{
	// initialize the queue
	q->first = 0;
	q->last  = 0;
}

queueElement* newQueueElement(int val)
{
	// allocate memory for the element
	queueElement* tmp = new queueElement;

	// fill the attributes of the element
	tmp->next = 0;
	tmp->val = val;

	// return the attribute (by reference!)
	return tmp;
}

////////////////////////////////////////////////////////////
// Basisfunktionen

bool isEmpty(fifoQueue* q)
{
	// check if the queue has a first element (is not empty)
	return q->first == 0;
}

void enqueue(fifoQueue* q, int val)
{
	// create a new element
	queueElement* element = newQueueElement(val);

	// check if this would be the very first element in the queue
	if (q->first == 0)
	{
		// the new element is the first *and* last element
		q->first = q->last = element;
	}
	else
	{		
		// the next element of the last element is the new element
		q->last->next = element;
		q->last = element;
	}
}

void dequeue(fifoQueue* q)
{
	// check if the queue is empty
	queueElement* first = q->first;
	if(first == 0) return;

	// remove element from the queue & free the memory
	q->first = q->first->next;
	delete first;
}

int front(fifoQueue* q)
{
	// check if the queue is empty!
	if(q->first == 0) return -1;	
	else return q->first->val;
}

int main(int argc, char** argv)
{
	// create and initialize a queue
	fifoQueue q;
	initNewQueue(&q);
	
	// fill our test numbers into the queue
	for (int i = 0; i < 10; i++)
	{
		enqueue(&q, i);
	}

	// print every second value in the queue
	cout << "Now printing every second number\n";
	while (!isEmpty(&q))
	{
		// print the even elements
		cout << front(&q) << endl;
		dequeue(&q);
		
		// skip the odd elements
		if (!isEmpty(&q))
		{
			dequeue(&q);
		}
	}

	// we're done!
	return 0;
}

////////////////////////////////////////////////////////////
